//==============================================================================
// WPBrowse WinPoint 95 sample Plugin        Copyright (C) 1998 Tim Schattkowsky
//==============================================================================
// LastRevision:
//   12.9.1998
//==============================================================================
// Description:
//   This plugin also demonstrates access to the messagebase and the usage of
//   area related services.
//==============================================================================
unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus, WPAPICommon, WinPointAPI;

type
  TForm1 = class(TForm)
    StatusBar: TStatusBar;
    WinPointAPI: TWinPointAPI;
    BrowseBAD: TWinPointService;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    AktiveServices1: TMenuItem;
    MenuBrowseBAD: TMenuItem;
    BrowseNETMAIL: TWinPointService;
    BrowseMessagebase: TWinPointService;
    MenuBrowseNETMAIL: TMenuItem;
    MenuBrowseMessagebase: TMenuItem;
    Area1: TMenuItem;
    Testmail1: TMenuItem;
    AreaLIst: TListBox;
    Panel1: TPanel;
    MsgTxt: TMemo;
    MessageLIst: TListView;
    Mail1: TMenuItem;
    AlsanSysopmarkieren1: TMenuItem;
    Flagszeigen1: TMenuItem;
    Connect1: TMenuItem;
    Disconnect1: TMenuItem;
    N1: TMenuItem;
    Beende1: TMenuItem;
    AreaBrowseHere: TAreaService;
    procedure AreaListClick(Sender: TObject);
    procedure WinPointAPIConnected(Sender: TObject);
    procedure WinPointAPIConnectFailed(Sender: TObject);
    procedure WinPointAPIConnecting(Sender: TObject);
    procedure WinPointAPIDisconnected(Sender: TObject);
    procedure WinPointAPIDisconnecting(Sender: TObject);
    procedure WinPointAPIServerDisconnected(Sender: TObject);
    procedure MenuBrowseBADClick(Sender: TObject);
    procedure BrowseBADCommand(Msg: TMsg);
    procedure BrowseNETMAILCommand(Msg: TMsg);
    procedure BrowseMessagebaseCommand(Msg: TMsg);
    procedure MenuBrowseNETMAILClick(Sender: TObject);
    procedure MenuBrowseMessagebaseClick(Sender: TObject);
    procedure WinPointAPIWrongVersion(Sender: TObject);
    procedure Testmail1Click(Sender: TObject);
    procedure MessageLIstChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure AlsanSysopmarkieren1Click(Sender: TObject);
    procedure Flagszeigen1Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure Beende1Click(Sender: TObject);
    procedure AreaBrowseHereCommand(Areas: TStringList; Msg: TMsg);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.AreaListClick(Sender: TObject);
var
  Res,i :Integer;
  Msgs  :TMessagelist;
begin
     if AreaList.ItemIndex>-1 then
     begin
          MessageList.Items.BeginUPdate;
          MessageList.Items.Clear;
          with AreaList do
          try
             WinPointAPI.OpenArea(Items[ItemIndex]);
             Msgs:=TMessagelist.Create;
             WinPointAPI.GetMsgList(Msgs);
             // Add the Items to the list!
             for i:=0 to MSgs.Count-1 do
             begin
                  with Msgs[i]^.MessageInfo do
                  with MessageList.Items.Add do
                  begin
                       Caption :=OrigName;
                       SubItems.Add(DestName);
                       SubItems.Add(Subject);
                  end;
             end;
             Msgs.ClearContent;
             Msgs.Destroy;
          except
            on EAPIError do;
          end;
          MessageList.Items.EndUPdate;
     end;
end;

procedure TForm1.WinPointAPIConnected(Sender: TObject);
begin
     StatusBar.Simpletext :='Verbunden';
     WinPointAPI.GetAreaList(AreaList.Items);
end;

procedure TForm1.WinPointAPIConnectFailed(Sender: TObject);
begin
     StatusBar.Simpletext :='Verbindungsversuch fehlgeschlagen';
end;

procedure TForm1.WinPointAPIConnecting(Sender: TObject);
begin
     StatusBar.Simpletext :='Verbinde ...';
end;

procedure TForm1.WinPointAPIDisconnected(Sender: TObject);
begin
     if not (csDestroying in ComponentState)
     then StatusBar.Simpletext :='Getrennt';
end;

procedure TForm1.WinPointAPIDisconnecting(Sender: TObject);
begin
     if not (csDestroying in ComponentState)
     then StatusBar.Simpletext :='Trenne ...';
end;

procedure TForm1.WinPointAPIServerDisconnected(Sender: TObject);
begin
     StatusBar.Simpletext :='Verbindung durch WinPoint getrennt';
end;

procedure TForm1.BrowseBADCommand(Msg: TMsg);
begin
     with AreaList do ItemIndex:=AreaList.Items.IndexOf('BAD');
     AreaListClick(Self);
     SetForegroundWindow(Handle);
end;

procedure TForm1.BrowseNETMAILCommand(Msg: TMsg);
begin
     with AreaList do ItemIndex:=AreaList.Items.IndexOf('NETMAIL');
     AreaListClick(Self);
     SetForegroundWindow(Handle);
end;

procedure TForm1.BrowseMessagebaseCommand(Msg: TMsg);
begin
     SetForegroundWindow(Handle);
end;

procedure TForm1.MenuBrowseBADClick(Sender: TObject);
begin
     with MenuBrowseBAD do
     begin
          Checked          :=not Checked;
          BrowseBad.Active :=Checked;
     end;
end;

procedure TForm1.MenuBrowseNETMAILClick(Sender: TObject);
begin
     with MenuBrowseNETMAIL do
     begin
          Checked              :=not Checked;
          BrowseNETMAIL.Active :=Checked;
     end;
end;

procedure TForm1.MenuBrowseMessagebaseClick(Sender: TObject);
begin
     with MenuBrowseMessageBase do
     begin
          Checked                  :=not Checked;
          BrowseMessageBase.Active :=Checked;
     end;
end;

procedure TForm1.WinPointAPIWrongVersion(Sender: TObject);
begin
     ShowMessage('Es wird eine hhere Winpoint-Version bentigt!');
end;

procedure TForm1.Testmail1Click(Sender: TObject);
var
  Newmail :PNewMail;
  NewSize :Integer;
  Lines   :String;
begin
     Lines   :='Testmail!'+#$0d+#$0a+';-)';
     NewSize :=SizeOf(TNewMail)+Length(Lines)+1;
     // Get clear buffe3r
     GetMem(NewMail,NewSize);
     FillChar(NewMail^,NewSize,0);
     // fill header
     with NewMail^ do
     begin
          OrigName :='WinPoint Browser Example';
          DestName :='Someone';
          Subject  :='Test';
          Origin   :='Just plugged in!';
          Size     :=NewSize;
     end;
     // Add Lines to header
     Move(Lines[1],Pointer(Integer(NewMail)+SizeOf(TNewMail))^,Length(Lines)+1);
     WinPointAPI.StoreMsg(NewMail);
     FreeMem(NewMail);
     // Refresh Display
     AreaListClick(Sender);
end;

procedure TForm1.MessageLIstChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
  Msg  :PPakdMessage;
  Data :Pointer;
  Destname, Origname, Subject, TheText,Temp :String;
  Position :Integer;
begin
     with MessageList do
     if Selected<>nil then              
     begin
          Msg:=WinPointAPI.GetMsg(Selected.Index);
          // Parse Message Body
          Data :=Msg;
          Inc(Integer(Data),SizeOf(TPakdMessage));
          Destname :=PChar(Data);
          Inc(Integer(Data),Length(DestName)+1);
          OrigName :=PChar(Data);
          Inc(Integer(Data),Length(OrigName)+1);
          Subject  :=PChar(Data);
          Inc(Integer(Data),Length(Subject)+1);
          TheText  :=PChar(Data);
          // Create the form
          with MsgTxt.Lines do
          begin
               BeginUpdate;
               Clear;
               // Add LInes from TheText
               Position:=Pos(#$0d,TheText);
               if Position=0 then Position:=Length(Text);
               repeat
                     Temp:=Copy(TheText,1,Position-1);
                     // Check for special styles
                     if Length(Temp)>0 then
                     begin
                          // Test for #$a from CR+LF
                          if Temp[1]=#$0a then System.Delete(Temp,1,1);
                          // Test for Ctrl-A
                          if (Length(Temp)>0) and (Temp[1]=#1)
                          then System.Delete(Temp,1,1);
                     end;
                     Add(Temp);
                     System.Delete(TheText,1,Position);
                     Position:=Pos(#$0d,TheText);
                     if Position=0 then Position:=Length(Text);
               until Length(TheTExt)=0;
               EndUpdate;
          end;
          // Done
          FreeMem(Msg);
     end;
end;

procedure TForm1.AlsanSysopmarkieren1Click(Sender: TObject);
begin
     WinPointAPI.SetMsgFlags(MessageList.Selected.Index,MFLG_TOSYSOP);
end;

procedure TForm1.Flagszeigen1Click(Sender: TObject);
begin
     ShowMessage(IntToStr(WinPointAPI.GetMsgFlags(MessageList.Selected.Index)));
end;

procedure TForm1.Connect1Click(Sender: TObject);
begin
     WinPointAPI.Connect;
end;

procedure TForm1.Disconnect1Click(Sender: TObject);
begin
     WinPointAPI.Disconnect;
     AreaList.Clear;
     MessageList.Items.Clear;
     MsgTxt.Clear;
end;

procedure TForm1.Beende1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.AreaBrowseHereCommand(Areas: TStringList; Msg: TMsg);
begin
     with AreaList do ItemIndex:=AreaList.Items.IndexOf(Areas[0]);
     AreaListClick(Self);
     SetForegroundWindow(Handle);
end;

end.
